# Manjaro ARM Tools
Contains scripts and files needed to build and manage manjaro-arm packages and images.

This software is available in the Manjaro repository.

*These tools only work on Manjaro based distributions!*


## Known issues
Check the [Issues](https://gitlab.manjaro.org/manjaro-arm/applications/manjaro-arm-tools/-/issues) page.

## Dependencies
These scripts rely on certain packages, other than what's in the `base` package group, to be able to function. These packages are:
* parted (arch repo)
* libarchive (arch repo)
* git (arch repo)
* binfmt-user-static (AUR) or manjaro-arm-qemu-static (manjaro repo)
	* If the above don't work and the script fails with weird errors, remove and try the belo packages instead
	* `yay -S qemu-user-static-bin binfmt-qemu-static`
* dosfstools (arch repo)
* polkit (arch repo)
* gnugpg (arch repo)
* wget (arch repo)
* systemd-nspawn with support for `--resolv-conf=copy-host` (arch repo)

### Optional Dependencies
* gzip (arch repo) (for `builddockerimg`)
* docker (arch repo) (for `builddockkerimg`)
* mktorrent (arch repo) (for torrent support in `deployarmimg`)
* rsync (arch repo) (for `deployarmimg`)
* bmap-tools (AUR or manjaro repo) (for BMAP support in `buildarmimg`)

# Installation (Manjaro based distributions only)
## GIT version from Manjaro Strit repo
Add my repo to your `/etc/pacman.conf`:
```
[manjaro-strit]
SigLevel = Optional
Server = https://www.strits.dk/files/manjaro-strit/manjaro-strit-repo/$arch
```
Run `sudo pacman -Syyu manjaro-arm-tools-git`.

## From gitlab (tagged or GIT version)
* git clone https://gitlab.manjaro.org/manjaro-arm/applications/manjaro-arm-tools.
* Extract it.
* Install `binfmt-qemu-static` package and make sure `systemd-binfmt` is running

Run `./setup.sh` to automatically create all needed symlinks

OR
* Copy the contents of `lib/` to `/usr/share/manjaro-arm-tools/lib/`.
* Copy the contents of `bin/` to `/usr/bin/`. Remember to make them executable.
* Create `/var/lib/manjaro-arm-tools/pkg` folder.
* Create `/var/lib/manjaro-arm-tools/img` folder.
* Create `/var/lib/manjaro-arm-tools/tmp` folder.
* Create `/var/cache/manjaro-arm-tools/img` folder.
* Create `/var/cache/manjaro-arm-tools/pkg` folder.

# Usage
## buildarmpkg
This script is used to create packages for ARM architectures.
It assumes you have filled out the PACKAGER section of your `/etc/makepkg.conf`.

Options inside `[` `]` are optional. Use `-h` to see what the defaults are.

**Syntax**

```
sudo buildarmpkg -p package [-a architecture] [-k] [-i package file] [-b branch]
```

To build an aarch64 package against arm-unstable branch use the following command:

```
sudo buildarmpkg -p package -a aarch64 -b unstable
```

You can also build `any` packages, which will use the aarch64 architecture to build from.

```
sudo buildarmpkg -p package -a any
```

The built packages will be copied to `$PKGDIR` as specified in `/usr/share/manjaro-arm-tools/lib/manjaro-arm-tools.conf` and placed in a subdirectory for the respective architecture.
Default package destination is `/var/cache/manjaro-arm-tools/pkg/`.

## signarmpkgs
This script uses the GPG identity you have setup in your /etc/makepkg.conf to sign the packages in the current folder.

```
cd <folder with built packages>
signarmpkgs
```

## buildarmimg
**Supported devices:**
* edgev
* enchilada (OnePlus 6)
* fajita (OnePlus 6T)
* gsking-x
* gtking-pro
* nanopc-t4
* nanopi-neo-plus2
* oc2
* oc4
* on2
* on2-plus (new)
* pine64-lts
* pine-h64
* pinebook
* pinephone
* pinetab
* pbpro
* rpi3 (not the A/B+ models it seems)
* rpi4
* rock64
* roc-cc
* rockpi4b
* rockpi4c (new)
* rockpro64
* stationp1
* vim1
* vim2
* vim3


**Supported editions:**

* minimal
* lxqt
* kde-plasma
* mate
* xfce
* i3
* sway
* gnome (experimental)
* plasma-mobile (experimental)
* phosh (experimental)
* cubocore (not complete yet)
* server (not complete yet, unmaintained)


This script will compress the image file and place it in `/var/cache/manjaro-arm-tools/img/`

Profiles that gets used are from this [Gitlab](https://gitlab.manjaro.org/manjaro-arm/applications/arm-profiles) repository.

**Syntax**

```
sudo buildarmimg [-d device] [-e edition] [-v version] [-n] [-x] [-i package-file.pkg.tar.xz] [-b branch] [-m]
```

To build a minimal image version 18.07 for the raspberry pi 3 on arm-unstable branch with bmap support:

```
sudo buildarmimg -d rpi3 -e minimal -v 18.07 -b unstable -m
```

To build a minimal version 18.08 RC1 for the odroid-c2 with a new rootfs downloaded:

```
sudo buildarmimg -d oc2 -e minimal -v 18.08-rc1 -n
```

To build an lxqt version with a local package installed for the rock64:

```
sudo buildarmimg -d rock64 -e lxqt -i package-name-1.0-1-aarch64.pkg.tar.xz
```

## Android Mainline devices

To port a new Android based device that supports the Mainline kernel do the following:

1. Add your device to arm-profiles, example: https://gitlab.com/sdm845-mainline/manjaro-arm/profiles/-/blob/oneplus6/devices/enchilada
2. Create a kernel package (SDM845 devices should use [the existing package](https://gitlab.com/sdm845-mainline/manjaro-arm/packages/-/tree/master/linux-sdm845)).
3. Create a device post-install package, example: https://gitlab.com/sdm845-mainline/manjaro-arm/packages/-/tree/master/oneplus6-post-install

The post-install package MUST contain a `deviceinfo.$CODENAME` file, where codename matches the name of the file you added to profiles. Use [the OnePlus 6 file](https://gitlab.com/sdm845-mainline/manjaro-arm/packages/-/blob/master/oneplus6-post-install/deviceinfo.enchilada) as an example, modify the values to match your device.

The `deviceinfo_zipfile_suffux` option must contain `-SLOT_a` or `-SLOT_b` for A/B devices, the installer will read the zip file name during install to determine which slot to flash to.


You also need a `$DEVICE.conf` to configure the screen scale and other options for lomiri, your .install file (script that runs after the package has been installed) should at a minimum contain [this line](https://gitlab.com/sdm845-mainline/manjaro-arm/packages/-/blob/master/oneplus6-post-install/oneplus6-post-install.install#L4) to let lomiri deviceinfo match the right device, the pretty name (e.g. `OnePlus 6`) should match the machine name of the device in DTS.

Any packages you have built manually will need to be added during the install process, see `/lib/functions.sh:299` for [an example](https://gitlab.com/sdm845-mainline/manjaro-arm/tools/-/blob/oneplus6/lib/functions.sh#L299).

Now, to build for your new Android device, simply run
```
sudo buildarmimg -d CODENAME -e lomiri -b unstable -a
```

The `-a` option tells the script that we're doing an Android build, as result it will create an ext4 rootfs image and pack it into a ZIP file that can be flashed in TWRP on your device. The installer will check that the device codename matches `CODENAME` during install, so it's important that the device profile matches.

## buildemmcinstaller
This script does almost the same as the `buildarmimg` script.

Except that it always creates a minimal image, with an already existing image inside it, only to be used for internal storage (eMMC) deployments.

**Syntax**
```
sudo buildemmcinstaller [-d device] [-e edition] -v version [-f flashversion] [-n] [-x] [-i package-file.pkg.tar.xz]
```

So to build an eMMC installer image for KDE Plasma 19.04 on Pinebook:
```
sudo buildemmcinstaller -d pinebook -e kde-plasma -v 19.04 -f first-emmc-flasher
```
Be aware that the device, edition and version, most already exist on the OSDN download page, else it won't work.


## buildrootfs
This script does exactly what it says it does. It builds a very small rootfs, to be used by the Manjaro ARM Installer and `buildarmimg`. Right now only supports `aarch64`.

**Syntax**
```
sudo buildrootfs
```

To build an aarch64 rootfs:
```
sudo buildrootfs
```

## builddockerimg
This script is similar to `buildrootfs`, except that it builds a rootfs ready for package building and turns it into a docker image, that can be uploaded to DockerHub.

**Syntax**
```
sudo builddockerimg
```
This uploads the docker file directly to the Manjaro ARM acccount on DockerHub.


## deployarmimg
This script will create checksums for and upload the newly generated image. It assumes you have upload access to our OSDN server.
If you don't, you can't use this.

**Syntax**

```
deployarmimg -i image [-d device] [-e edition] [-v version] -k email@server.org [-t] [-u osdn-username]
```

To upload an image to the raspberry pi minimal 18.07 folder use with torrent:

```
deployarmimg -i Manjaro-ARM-minimal-rpi3-18.07.img.xz -d rpi3 -e minimal -v 18.07 -k email@server.org -t
```

## getarmprofiles
This script will just clone or update the current profile list in `/usr/share/manjaro-arm-tools/profiles/`.
So nothing fancy.

This would enable users to clone the profiles repository, make any changes they would like to their images and then build them locally.
So if you made changes to the profiles yourself, don't run `getarmprofiles` and you will still have your edits.

But if you messed up your profiles somehow, you can start with the repo ones with:
```
sudo getarmprofiles -f
```
